#ifndef CHROME_KNOWLEDGE_IMAGE_SEARCH_ICA_INTERFACE_H_
#define CHROME_KNOWLEDGE_IMAGE_SEARCH_ICA_INTERFACE_H_

#include <stdint.h>

extern "C" {

struct ImageContentAnnotator;

ImageContentAnnotator* CreateImageContentAnnotator();
typedef decltype(&CreateImageContentAnnotator) CreateImageContentAnnotatorFn;

void DestroyImageContentAnnotator(ImageContentAnnotator* annotator);
typedef decltype(&DestroyImageContentAnnotator) DestroyImageContentAnnotatorFn;

bool InitImageContentAnnotator(ImageContentAnnotator* annotator,
                               const char* locale);
typedef decltype(&InitImageContentAnnotator) InitImageContentAnnotatorFn;

bool AnnotateImage(ImageContentAnnotator* annotator, const uint8_t* rgb_bytes,
                   int width, int height, int line_stride,
                   uint8_t** result_data, int32_t* result_size);
typedef decltype(&AnnotateImage) AnnotateImageFn;

bool AnnotateEncodedImage(ImageContentAnnotator* annotator,
                          const uint8_t* encoded_bytes, int len,
                          uint8_t** result_data, int32_t* result_size);
typedef decltype(&AnnotateEncodedImage) AnnotateEncodedImageFn;

bool GetLocalizedMidNames(ImageContentAnnotator* annotator,
                          uint8_t** result_data, int32_t* result_size);
typedef decltype(&GetLocalizedMidNames) GetLocalizedMidNamesFn;

void DeleteAnnoteImageResult(uint8_t* result_data);
typedef decltype(&DeleteAnnoteImageResult) DeleteAnnoteImageResultFn;

}  // extern "C"

#endif  // CHROME_KNOWLEDGE_IMAGE_SEARCH_ICA_INTERFACE_H_
